您的位置:首頁 > 教程 > linux > 詳解bash中的退出狀態機制

詳解bash中的退出狀態機制

2022-06-19 07:25:54 來源:易采站長站 作者:

詳解bash中的退出狀態機制

這篇文章主要介紹了詳解bash中的退出狀態機制,文中通過示例代碼介紹的非常詳細,對大家的學習或者工作具有一定的參考學習價值,需要的朋友們下面隨著小編來一起學習學習吧jov站長之家-易采站長站-Easck.Com

程序的退出狀態jov站長之家-易采站長站-Easck.Com
jov站長之家-易采站長站-Easck.Com

當一個程序結束時會向父進程報告自己的退出狀態( exit status ). 通過傳遞 int 類型的變量給庫函數 exit 或系統調用 _exit 可以設置當前程序的退出狀態, 在 linux 中, 通過 WEXITSTATUS 返回的退出狀態的值域為 [0, 255] 之間的整數 . 如果傳遞的值不在這個范圍內, 內核會自動幫你強轉為 u_int8_t . 通過 waitpid 庫函數可以得到子進程的退出狀態, 其值存儲在參數 wstatus 的低 8 位中.jov站長之家-易采站長站-Easck.Com

// 定義在 wait.h 中
# define WEXITSTATUS(status)  __WEXITSTATUS (status)

// 定義在 waitstatus.h 中
/* If WIFEXITED(STATUS), the low-order 8 bits of the status. */
#define  __WEXITSTATUS(status)  (((status) & 0xff00) >> 8)

下面這個例子展示了如何使用 waitpid 及相關宏函數獲取子進程的退出狀態:jov站長之家-易采站長站-Easck.Com

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>

#define PARENT_EXIT 10086
#define CHILD_EXIT -10

int main()
{
  pid_t pid = fork();

  if (pid > 0)
  {
    int wstatus;
    // 父進程等待子進程執行完畢, 用 WUNTRACED 選項追蹤已結束的子進程
    pid_t child_pid = waitpid(pid, &wstatus, WUNTRACED);

    if (WIFEXITED(wstatus))
      printf("Child exit status: %d\n", WEXITSTATUS(wstatus));
    else
      perror("Bad wait status\n");

    // 父進程退出
    exit(PARENT_EXIT);
  }
  else if (pid == 0)
  {
    // 子進程立即退出, 因此需要父進程設置 WUNTRACED
    exit(CHILD_EXIT);
  }
  else
  {
    // 處理 fork 時出現的錯誤
    perror("fork\n");
    exit(EXIT_FAILURE);
  }
}

編譯并運行上例可以得到被強轉后的狀態碼, 我們使用 WIFEXITED 判斷等待的子進程是否執行成功, 然后對執行成功子進程使用 WEXITSTATUS 獲取其退出狀態. 對程序來說, 最終的退出狀態就是主進程的退出狀態.jov站長之家-易采站長站-Easck.Com

> gcc ecitcode.c;./a.out;echo "Parent exit status: $?"
Child exit status: 246 # -10 強轉為 uint8
Parent exit status: 102 # 10086 強轉為 uint8

在 POSIX 標準中規定退出狀態 0 代表該程序正常退出, 1 代表發生錯誤, 其他數字由程序自行規定, 因此在 glibc 的 stdlib.h 中僅定義了如下宏:jov站長之家-易采站長站-Easck.Com

#define EXIT_FAILURE  1    /* Failing exit status. */
#define EXIT_SUCCESS  0    /* Successful exit status. */

程序本身一般會在文檔中事先約定每種退出狀態代表的退出原因( termination ), 例如在 ls 的幫助文檔中:jov站長之家-易采站長站-Easck.Com

> ls --help
...其他內容...
Exit status: # 退出狀態
 0 if OK, # 正常執行
 1 if minor problems # 次要問題, 例如: 無法訪問子目錄
 2 if serious trouble # 嚴重錯誤, 例如: 無法訪問命令行參數
...其他內容...

命令的退出狀態jov站長之家-易采站長站-Easck.Com
jov站長之家-易采站長站-Easck.Com

在 bash 中會記錄所執行命令的退出狀態, 可以通過 $? 獲取最近執行的命令的退出狀態. bash 自身的退出狀態為執行的最后一條命令的退出狀態, 也就等價于顯式指定 exit $? . 如果沒有執行任何命令就退出, 則 bash 的退出狀態為 0 , 要注意在 bash 中用 0 表示 true , 用非零表示 false .jov站長之家-易采站長站-Easck.Com

# 用 exit 顯式指定退出狀態
> bash
> exit 98
exit
> echo $?
98

# 什么也不執行則退出狀態為 0
> bash
exit # Ctrl + D 退出
> echo $?
0

# 默認為最后一條命令的退出狀態
> bash
> ecasd
ecasd: command not found
exit # Ctrl + D 退出
> echo $?
127

在 bash 中對不同種類命令的退出狀態作出如下規定:jov站長之家-易采站長站-Easck.Com

內置命令: 由于內置命令執行時不需要啟動額外的子進程, 因此需要用返回值模擬退出狀態. 每個函數都定義了自己的退出狀態, 例如: 內置命令 source 將腳本文件的最后一個命令的返回狀態作為命令的返回狀態. bash 中所有的內置命令都用退出狀態 2 表示用法錯誤, 例如: 選項錯誤, 缺少參數.jov站長之家-易采站長站-Easck.Com

> cd -+- # 錯誤的參數
bash: cd: -+: invalid option
cd: usage: cd [-L|[-P [-e]] [-@]] [dir]
> echo $?
2

外部命令: 外部命令的退出狀態就是使用 waitpid 得到的子進程的退出狀態, 如果子進程在執行過程被編號為 N 的信號所終止, 則得到的退出狀態就為 128+N .jov站長之家-易采站長站-Easck.Com

Shell 函數: 定義 shell 函數時, 函數名與之前已定義的只讀函數名相同則退出狀態為 1 , 當發生語法錯誤則退出狀態為 2 . 執行 shell 函數時, 函數中最后執行的一條命令的退出狀態就是整個函數的退出狀態.jov站長之家-易采站長站-Easck.Com

# 二次定義只讀函數報錯
> func () { echo; }
> readonly -f func
> func; echo $?
0
> func () { echo poi; }
bash: func: readonly function
> echo $?
1

# 定義函數發生語法錯誤
> fune () {aa}
bash: syntax error near unexpected token '{aa}'
> echo $?
2

# 函數的退出狀態是最后執行的命令的退出狀態
> funr () { echo; return 6; }
> funr; echo $?
  # echo 打印的空行
6 # return 6 是函數中最后執行的命令

表達式: 使用 ((...)) 或 let 修飾的表達式的退出狀態取決于表達式的值, 如果表達式的值為 0 則退出狀態為 1 ; 如果表達式的值為非零, 則退出狀態為 0 .jov站長之家-易采站長站-Easck.Com

> let 0+0; echo $?
1 # 表達式值為零
> ((7-5)); echo $?
0 # 表達式值非零

命令列表: 用 ; , & , && , || 連接命令被稱為命令列表, 其中用 && 和 || 連接的命令使用左關聯( left associativity )模式執行列表中的命令. 整個命令列表的退出狀態為最后一條命令的退出狀態. 此外, $( LISTS ) 以及流程控制結構如: for , while 等的返回狀態也是結構中的命令列表的退出狀態.jov站長之家-易采站長站-Easck.Com

# 功能: 能ping通baidu.com則輸出 `baidu.com is up` , 否則輸出 `baidu.com is down` 。
> ping -c1 baidu.com &> /dev/null && echo 'baidu.com is up' || echo 'baidu.com is down'
baidu.com is down
> echo $?
0 # 無論是否能 ping 通, 命令列表的退出狀態都等于最后一條命令的退出狀態

左關聯模式被廣泛應用于各種語言的邏輯運算符優化中. 對于邏輯與運算符 && , 以 eq1 && eq2 為例, 只有當兩邊都為 True 才會返回 True , 因此當 eq1 為 False 時, eq2 不會執行; 對于邏輯或運算符 || , 以 eq1 || eq2 為例, 只要兩邊有一個 True 就會返回 True , 因此當 eq1 為 True 時, eq2 不會執行。jov站長之家-易采站長站-Easck.Com

腳本: 使用 . 或 source 運行腳本文件等同于在當前 bash 中執行代碼塊, 腳本中最后執行的命令的退出狀態就是腳本的退出狀態. 使用 ./腳本名 或 bash 腳本名 的方式執行腳本文件等同于執行外部命令, 腳本的退出狀態就是外部命令 bash 的退出狀態. 如果腳本中最后執行的命令是 exit , 那么使用 . 或 source 執行該腳本文件在執行結束后會退出當前 bash .jov站長之家-易采站長站-Easck.Com

后臺作業與協作進程: 使用不帶選項的 wait 命令可以獲得最后一個執行完畢的后臺作業的退出狀態, 如果使用 wait -n <jobsec> 可以獲得指定后臺作業的退出狀態, 如果作業不存在則退出狀態為 127 . 使用 coproc 在 sub shell 中執行的命令的退出狀態和后臺作業一樣可以被 wait 獲取, coproc 自身的退出狀態始終為 0 .jov站長之家-易采站長站-Easck.Com

> { sleep 10; aad; } &
[1] 558
> wait -n 1
[1]+ Exit 127        { sleep 10; aad; }

> coproc { sleep 10; aad; }
[1] 558
> echo $?
0 # 這是 coproc 的執行結果
> jobs
[1]+ Exit 127        coproc COPROC { sleep 10; aad; }

管道命令: 默認情況下, 管道的退出狀態取決于管道中最后一條命令的退出狀態. 如果設置了 set -o pipefail , 那么只有在管道中的全部命令的退出狀態為 0 時, 整個管道的退出狀態才為 0 , 否則就是最后一個非零的退出狀態. 在管道前添加 ! 符號可以對整個管道的退出狀態取反. bash 中的特殊變量 $PIPESTATUS 以數組的形式存儲最近執行的前臺管道的退出狀態, 要注意的是單個命令也會被記錄, 也就是說 ${PIPESTATUS[0]} 和 $? 是等價的.jov站長之家-易采站長站-Easck.Com

# 管道的退出狀態是最后一條命令的退出狀態
> ps | xxp 2>/dev/null | cat; echo $?
0
> set -o pipefail 
> ps | xxp 2>/dev/null | cat; echo $?
127 # 設置了 pipefail 因此得到最后一個非零退出狀態

# 管道中每個命令的退出狀態被按順序記錄在數組中
> easd 2>/dev/null | ls /nou 2>/dev/null | more 2>/dev/null
> echo ${PIPESTATUS[@]}
127 2 0

# 不帶管道符號的單個命令也會被記錄
> ping asbasdasd 2>/dev/null; echo ${PIPESTATUS[0]}
2
> ping asbasdasd 2>/dev/null; echo $?
2

參考資料jov站長之家-易采站長站-Easck.Com
jov站長之家-易采站長站-Easck.Com

Exit status rangejov站長之家-易采站長站-Easck.Com
Baswww.cppcns.comh man pagejov站長之家-易采站長站-Easck.Com

以上就是詳解bash中的退出狀態機制的詳細內容,更多關于bash 退出狀態 的資料請關注我們其它相關文章!jov站長之家-易采站長站-Easck.Com

如有侵權,請聯系QQ:279390809 電話:15144810328

相關文章

  • Linux下用GHOST來做系統備份

    Linux下用GHOST來做系統備份

    在Windows系統下備份我們可以用GHOST工具軟件完成,Linux系統不能完全依賴于GHOST工具,一則是GHOST本身是有版權的軟件,二是GHOST只支持ext2、ext3文件系統的Linux分區,不支持reiserfs、xfs等
    2019-10-25
  • 給 FreeBSD 12.1 安裝 GNOME3 圖形界面

    給 FreeBSD 12.1 安裝 GNOME3 圖形界面

    FreeBSD是一個完全開放的、安全的系統,可以Do it yourself的系統。但是個人還是不喜歡呆板的命令行界面,所有就給 FreeBSD 12.1 安裝 GNOME3 圖形界面。 開始操作,啟動FreeBSD 12.1,以root身份
    2019-10-27
  • Ubuntu Studio一個不錯的操作系統

    Ubuntu Studio一個不錯的操作系統

    Ubuntu Studio 是一個基于 Ubuntu 而面向音頻、視頻及圖形愛好者的操作系統。本次推出的 Ubuntu Studio 為 7.04 版,目前僅支持 Intel i386 兼容的處理器。 Ubuntu Studio 從大量的開源多媒體創作程序
    2019-10-25
  • 最受歡迎的10款Linux免費游戲

    最受歡迎的10款Linux免費游戲

    圖為在Linux下運行的免費游戲America's Army 如果你認為 Linux下沒有什么好游戲的話,那就錯了!我們來看看Linux下最受歡迎的10款游戲吧,而且這些游戲都是完全免費的! # skyreal update(06-12
    2019-10-25
  • compiz fusion特效使用心得(附3D桌面圖)

    compiz fusion特效使用心得(附3D桌面圖)

    3D桌面圖 LINUX發行版就是好,當大多數人還在沉迷于那些什么風格圖標鳥玻璃效果甚至孜孜不倦津津樂道的時候,Linux的高手們已經悄悄為我們開啟了一個桌面系統3D的時代。 當我第一次
    2019-10-25
  • Ubuntu 下aMule 的安裝配置

    Ubuntu 下aMule 的安裝配置

    aMule 是一個類似于 eMule 的多平臺 P2P 客戶端程序。以下將簡略敘述 aMule 在 Ubuntu 中的安裝及配置 [High ID] 與 [KAD] 的過程。 安裝: sudo apt-get install amule sudo apt-get install amule-utils 如果需要
    2019-10-25
  • JMeter jp@gc - stepping thread group插件

    JMeter jp@gc - stepping thread group插件

    這是一個出單接口壓力測試的小例子,了解一下壓力測試最最基礎的基礎。出單接口是用來保險出單的,不需要在UI界面下一步下一步的出單,接口一調數據入庫完事~~~。再啰嗦一句接
    2019-10-27
  • Ubuntu 下使用K3B軟件刻錄光盤(圖)

    Ubuntu 下使用K3B軟件刻錄光盤(圖)

    不知大家會不會在Ubuntu下刻錄光盤呢?k3b是KDE環境下的一個CD/DVD刻錄軟件,有非常容易使用的界面,功能比較齊全。用起來感覺就象是win下的Nero一樣簡單自然,比ubuntu里原來的刻錄CD方式
    2019-10-25
色七七影院_香港三级台湾三级在线播放_男人放进女人阳道猛进猛出